/**************************************************************************
* /dev/iptrk device for Linux 2.6 kernel
* Copyright (C) 2003 Jason Nunn <jsno@leal.com.au>
* Darwin, NT, Australia. 
* Originally developed for Arafura Connect (Dec 2000 - Mar 2003)
* Donated to GPL before liquidation.
*
* =================================================================
* common defs
*
**************************************************************************/
#ifndef _LINUX_IPTRK_H
#define _LINUX_IPTRK_H

#include <linux/skbuff.h>
#include <linux/spinlock.h>
#include <asm/atomic.h>

#define IPTRK_KERNEL_REVISION	"16"
#define IPTRK_IF_SIZE		8
#define IPTRK_MAJOR		201

typedef struct
{
  char  dev[IPTRK_IF_SIZE + 1];
  __u32 ip_s;
  __u32 ip_d;
  __u16 tot_len;
  __u8  protocol;
  __u16 port_s;  /*only applic. to tcp and udp protocols*/
  __u16 port_d;  /*...*/
} iptrk_queue_t;

extern spinlock_t    iptrk_lock;
extern atomic_t      iptrk_active_f;

extern iptrk_queue_t *iptrk_queue;
extern int           iptrk_queue_size,
                     iptrk_queue_iptr,
                     iptrk_queue_count,
                     iptrk_overflow_count;

extern void push_iptrk(struct sk_buff *skb);

#endif /* _LINUX_IPTRK_H */
